"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from alph_sdk.types import BaseModel, Nullable, OptionalNullable, UNSET, UNSET_SENTINEL
from pydantic import model_serializer
from typing import Any, Dict, List, Optional
from typing_extensions import NotRequired, TypedDict


class AddProjectRequestTypedDict(TypedDict):
    name: NotRequired[str]
    organization_id: NotRequired[str]
    port: NotRequired[float]
    port_forward_url: NotRequired[str]
    server_request: NotRequired[str]
    thumb: NotRequired[str]
    token: NotRequired[str]
    url: NotRequired[str]


class AddProjectRequest(BaseModel):
    name: Optional[str] = None

    organization_id: Optional[str] = None

    port: Optional[float] = None

    port_forward_url: Optional[str] = None

    server_request: Optional[str] = None

    thumb: Optional[str] = None

    token: Optional[str] = None

    url: Optional[str] = None


class AddProjectOrganizationTypedDict(TypedDict):
    avatar_url: NotRequired[Nullable[Any]]
    id: NotRequired[str]
    name: NotRequired[str]
    slug: NotRequired[str]


class AddProjectOrganization(BaseModel):
    avatar_url: OptionalNullable[Any] = UNSET

    id: Optional[str] = None

    name: Optional[str] = None

    slug: Optional[str] = None

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["avatar_url", "id", "name", "slug"]
        nullable_fields = ["avatar_url"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m


class AddProjectProjectTypedDict(TypedDict):
    avatar_url: NotRequired[str]
    created_at: NotRequired[str]
    id: NotRequired[str]
    image_reference: NotRequired[str]
    name: NotRequired[str]
    organization: NotRequired[AddProjectOrganizationTypedDict]
    port: NotRequired[float]
    port_forward_url: NotRequired[str]
    slug: NotRequired[str]
    status: NotRequired[str]
    url: NotRequired[str]
    user_id: NotRequired[str]


class AddProjectProject(BaseModel):
    avatar_url: Optional[str] = None

    created_at: Optional[str] = None

    id: Optional[str] = None

    image_reference: Optional[str] = None

    name: Optional[str] = None

    organization: Optional[AddProjectOrganization] = None

    port: Optional[float] = None

    port_forward_url: Optional[str] = None

    slug: Optional[str] = None

    status: Optional[str] = None

    url: Optional[str] = None

    user_id: Optional[str] = None


class AddProjectResponseBodyTypedDict(TypedDict):
    r"""Add Project"""

    message: NotRequired[str]
    project: NotRequired[AddProjectProjectTypedDict]
    status: NotRequired[str]


class AddProjectResponseBody(BaseModel):
    r"""Add Project"""

    message: Optional[str] = None

    project: Optional[AddProjectProject] = None

    status: Optional[str] = None


class AddProjectResponseTypedDict(TypedDict):
    headers: Dict[str, List[str]]
    result: AddProjectResponseBodyTypedDict


class AddProjectResponse(BaseModel):
    headers: Dict[str, List[str]]

    result: AddProjectResponseBody
